"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require("./");
const URI = require("urijs");
class SingleProcessDiscovery extends _1.Discovery {
    constructor() {
        super(...arguments);
        this.serviceHandles = [];
    }
    registerService(service, address, port) {
        return __awaiter(this, void 0, void 0, function* () {
            const baseRoute = Reflect.get(service.constructor, 'baseRoute');
            if (!baseRoute) {
                return;
            }
            const fullBase = URI(`http://${address}:${port}/`).pathname(baseRoute).toString();
            const serviceHandle = {
                name: Reflect.get(service.constructor, 'serviceName') || service.constructor.name,
                serviceUrl: fullBase,
                tags: service.tags || [],
            };
            this.serviceHandles.push(serviceHandle);
        });
    }
    unregisterService(service) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceHandle = this.serviceHandles.find(s => s.name === (Reflect.get(service.constructor, 'serviceName') || service.constructor.name));
            if (serviceHandle) {
                let index = this.serviceHandles.indexOf(serviceHandle);
                if (index >= 0) {
                    this.serviceHandles.splice(index, 1);
                }
            }
        });
    }
    findAll(name, tags) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.serviceHandles.filter((handle) => {
                return handle.name === name;
            }).filter((handle) => {
                if (tags) {
                    let found = false;
                    for (const t of tags) {
                        if (handle.tags.find(t2 => t2 === t)) {
                            found = true;
                        }
                    }
                    return found;
                }
                else {
                    return true;
                }
            });
        });
    }
}
exports.SingleProcessDiscovery = SingleProcessDiscovery;
//# sourceMappingURL=SingleProcessDiscovery.js.map